"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// src/node/useNodeWorker.ts
var import_node_worker_threads = __toESM(require("worker_threads"), 1);
var import_node_path5 = __toESM(require("path"), 1);
var import_node_process2 = __toESM(require("process"), 1);

// src/is/isArray.ts
var isArray = Array.isArray;

// src/is/isStr.ts
function isStr(o) {
  return typeof o === "string";
}

// src/is/isBool.ts
function isBool(value) {
  return typeof value === "boolean";
}

// src/is/isExist.ts
var import_node_fs = __toESM(require("fs"), 1);

// src/to/toAbsolutePath.ts
var import_node_process = __toESM(require("process"), 1);
var import_node_path = __toESM(require("path"), 1);

// src/is/isFile.ts
var import_node_fs2 = __toESM(require("fs"), 1);

// src/is/isGo.ts
var import_node_path2 = __toESM(require("path"), 1);

// src/node/jsShell.ts
var import_node_child_process = __toESM(require("child_process"), 1);
function jsShell(commander, args = [], stdio = "inherit", errorExit, isLog) {
  if (isBool(args)) {
    errorExit = args;
    args = [];
    stdio = "inherit";
  } else if (isStr(args)) {
    stdio = args;
    args = [];
  }
  return isArray(commander) ? commander.map((command) => executor(command)) : executor(commander);
  function executor(commander2) {
    var _a;
    const { status, output } = import_node_child_process.default.spawnSync(
      commander2,
      args,
      {
        shell: true,
        encoding: "utf8",
        stdio: stdio === "inherit" ? "inherit" : ["inherit", "pipe", "inherit"]
      }
    );
    const result = (_a = output[1]) == null ? void 0 : _a.trim();
    if (status === 130) {
      if (isLog)
        console.log("\u5DF2\u53D6\u6D88...");
      return { status, result };
    }
    if (status !== 0) {
      if (isLog)
        console.log(result);
      if (errorExit)
        process.exit(1);
    }
    return { status, result };
  }
}

// src/is/isPkg.ts
var import_node_path3 = __toESM(require("path"), 1);

// src/is/isRust.ts
var import_node_path4 = __toESM(require("path"), 1);

// src/is/isWritable.ts
var import_node_fs3 = __toESM(require("fs"), 1);

// src/node/useNodeWorker.ts
function useProcressNodeWorker(callback) {
  const { parentPort } = import_node_worker_threads.default;
  parentPort.on(
    "message",
    async (data) => parentPort == null ? void 0 : parentPort.postMessage(await (callback == null ? void 0 : callback(data)) || (() => ""))
  );
}

// src/worker/useNodeWorkerThread.ts
useProcressNodeWorker(
  ({ params, stdio = "pipe", errorExit, isLog }) => jsShell(`${params}`, stdio, errorExit, isLog)
);
